#info Notice: set Render mode to Continous
#info Theli-at's Pseudo Kleinian (Scale 1 JuliaBox + Something
#include "colorpalette.frag"
#include "DE-Raytracer.frag"
#include "MathUtils.frag"
#group PseudoKleinian

#define USE_INF_NORM

// Made by Knighty, see this thread:
// http://www.fractalforums.com/3d-fractal-generation/fragmentarium-an-ide-for-exploring-3d-fractals-and-other-systems-on-the-gpu/msg32270/#msg32270


uniform int MI; slider[0,5,20]
uniform int ColorIterations;  slider[0,3,300]
//uniform float Bailout; slider[0,20,1000]
uniform float Size; slider[0,1,2]
uniform vec3 CSize; slider[(0,0,0),(1,1,1),(2,2,2)]
uniform vec3 C; slider[(-2,-2,-2),(0,0,0),(2,2,2)]
uniform float TThickness; slider[0,0.01,2]
uniform float DEoffset; slider[0,0,0.01]
uniform vec3 Offset; slider[(-1,-1,-1),(0,0,0),(1,1,1)]

float RoundBox(vec3 p, vec3 csize, float offset)
{
	vec3 di = abs(p) - csize;
	float k=max(di.x,max(di.y,di.z));
	return abs(k*float(k<0.)+ length(max(di,0.0))-offset);
}

float Thingy(vec3 p, float e){
	p-=Offset;
	return (abs(length(p.xy)*p.z)-e) / sqrt(dot(p,p)+abs(e));
}

float Thing2(vec3 p){
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<MI && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
      
		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);

		p*=k;DEfactor*=k;
      
		p+=C;
		orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
	}
	//Call basic shape and scale its DE
	//return abs(0.5*Thingy(p,TThickness)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
	return abs(0.5*abs(p.z-Offset.z)/DEfactor-DEoffset);
}

float DE(vec3 p){
	return  Thing2(p);//RoundBox(p, CSize, Offset);
}

float Coloring(vec3 p){
	float expsmooth=0.0;
	float r1 = 0.0, r2 = 0.0;
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<ColorIterations && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
      
		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);

		p*=k;DEfactor*=k;
      
		p+=C;
		orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
		expsmooth+=exp(-1.0/abs(r1-r2));	
	}
	//Call basic shape and scale its DE
	//return abs(0.5*Thingy(p,TThickness)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
	
	
	return expsmooth;
}


#preset default
Color1 = 0.9490196,1,0.9647059
Color2 = 0.4470588,0.7137255,1
Color3 = 1,0.7098039,0.4196078
ColorOffset = 5.564697
FOV = 0.5
Eye = 6.852083,-0.1880047,-3.675254
Target = -1.868213,2.499964,-5.23992
Up = -0.1045081,0.2085856,0.9407843
Gamma = 0.8
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1.8
Saturation = 1
GaussianWeight = 2
AntiAliasScale = 2
Detail = -3.49335
FudgeFactor = 0.31434
Dither = 0.30219
NormalBackStep = 0 NotLocked
CamLight = 0.945098,0.92549,0.815686,1.278839
BaseColor = 0.6588235,0.7803922,0.7803922
OrbitStrength = 0.6819205
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.5647059,0.6,0.6
GradientBackground = 0
CycleColors = false
Cycles = 1.1
EnableFloor = true
FloorNormal = 0,0,1
FloorHeight = -5
FloorColor = 0.568627,0.564706,0.443137
AO = 0,0,0,0.7
CamLightMin = 0.0384906
ColorDensity = 0.416293
EquiRectangular = false
AutoFocus = false
FocalPlane = 6.13028
Aperture = 0
DepthToAlpha = true
ShowDepth = false
DepthMagnitude = 1
DetailAO = -1.86109
MaxDistance = 216.22
MaxRaySteps = 2283
Specular = 0.23552
SpecularExp = 100
SpecularMax = 10
SpotLight = 1,0.678431,0.411765,1
SpotLightDir = 0.4996221,0.3983371
Glow = 1,0.9529412,0.7529412,0.2233083
GlowMax = 370
Fog = 0.4886613
HardShadow = 1 NotLocked
ShadowSoft = 0.4996215
QualityShadows = true
Reflection = 0.7913239 NotLocked
DebugSun = false NotLocked
MI = 12
ColorIterations = 27
Size = 1.786237
CSize = 1.03042,1.04424,2
C = 0.15624,0,0
TThickness = 0.01
DEoffset = 0
Offset = 0,0,0
#endpreset



#preset 1
Color1 = 0.4666667,1,0.7333333
Color2 = 0.4470588,0.7137255,1
Color3 = 1,0.5490196,0.1803922
ColorDensity = 0.1890882
ColorOffset = 4.674644
FOV = 0.5
Eye = 6.852083,-0.1880047,-3.675254
Target = -0.9067125,1.752036,-8.3394
Up = -0.4205383,0.2946083,0.8221061
AutoFocus = false
Gamma = 0.8
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1.8
Saturation = 1
GaussianWeight = 2
AntiAliasScale = 2
DepthToAlpha = true
Detail = -3.153619
FudgeFactor = 0.31434
Dither = 0.30219
NormalBackStep = 0
CamLight = 0.945098,0.92549,0.815686,1.278839
BaseColor = 0.6588235,0.7803922,0.7803922
OrbitStrength = 0.6819205
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.5647059,0.6,0.6
GradientBackground = 0
CycleColors = false
Cycles = 1.1
EnableFloor = true
FloorNormal = 0,0,1
FloorHeight = -5
FloorColor = 0.568627,0.564706,0.443137
MI = 12
ColorIterations = 27
Size = 1.786237
CSize = 1.03042,1.04424,2
C = -1.941776,0.0640466,-0.1513828
TThickness = 0.01
DEoffset = 0
Offset = 0,0,0
EquiRectangular = false
FocalPlane = 0.5271084
Aperture = 0.0081967
ShowDepth = false
DepthMagnitude = 1
DetailAO = -1.86109
MaxDistance = 216.22
MaxRaySteps = 2283
AO = 0,0,0,0.7
Specular = 0.23552
SpecularExp = 100
SpecularMax = 10
SpotLight = 1,0.678431,0.411765,1
SpotLightDir = 0.4996221,0.3983371
CamLightMin = 0.0384906
Glow = 1,0.9529412,0.7529412,0.2233083
GlowMax = 370
Fog = 1.379663
HardShadow = 1 NotLocked
ShadowSoft = 0.4996215
QualityShadows = true
Reflection = 0.7913239 NotLocked
DebugSun = false NotLocked
#endpreset



#preset 2
Color1 = 1,0.8,0.003921569
Color2 = 0.1607843,0.2431373,1
Color3 = 0.745098,0.1019608,0.1019608
ColorDensity = 0
ColorOffset = 5.228123
FOV = 0.5
Eye = 6.87671,-0.2281204,-3.760978
Target = -1.444743,1.963053,-7.176985
Up = -0.2948338,0.2610625,0.8856773
AutoFocus = false
Gamma = 0.8
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1.8
Saturation = 1
GaussianWeight = 2
AntiAliasScale = 2
DepthToAlpha = true
Detail = -3.153619
FudgeFactor = 0.31434
Dither = 0.30219
NormalBackStep = 0
CamLight = 0.945098,0.92549,0.815686,1.278839
BaseColor = 0.6588235,0.7803922,0.7803922
OrbitStrength = 0.6819205
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.5647059,0.6,0.6
GradientBackground = 0
CycleColors = false
Cycles = 1.1
EnableFloor = true
FloorNormal = 0,0,1
FloorHeight = -5
FloorColor = 0.568627,0.564706,0.443137
MI = 12
ColorIterations = 11
Size = 1.364568
CSize = 1.03042,1.04424,2
C = 2,0.0640466,-0.1513828
TThickness = 0.01
DEoffset = 0
Offset = 0,-0.0444444,0.68
EquiRectangular = false
FocalPlane = 0.6400602
Aperture = 0.0081967
ShowDepth = false
DepthMagnitude = 1
DetailAO = -1.86109
MaxDistance = 216.22
MaxRaySteps = 2283
AO = 0,0,0,0.7
Specular = 0.23552
SpecularExp = 100
SpecularMax = 10
SpotLight = 1,0.678431,0.411765,1
SpotLightDir = 0.4996221,0.3983371
CamLightMin = 0.0384906
Glow = 1,0.9529412,0.7529412,0.2233083
GlowMax = 370
Fog = 0.5852231
HardShadow = 1 NotLocked
ShadowSoft = 0.4996215
QualityShadows = true
Reflection = 0.7913239 NotLocked
DebugSun = false NotLocked
#endpreset



#preset 3
Color1 = 0.9058824,0.4313725,1
Color2 = 0.5490196,0.09019608,0.7411765
Color3 = 1,0.9921569,0.7607843
ColorDensity = 0.2757848
ColorOffset = 9.094989
FOV = 0.5
Eye = 6.87671,-0.2281204,-3.760978
Target = -1.444743,1.963053,-7.176985
Up = -0.2948339,0.2610625,0.8856773
AutoFocus = false
Gamma = 0.8
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1.8
Saturation = 1
GaussianWeight = 2
AntiAliasScale = 2
DepthToAlpha = true
Detail = -3.153619
FudgeFactor = 0.31434
Dither = 0.30219
NormalBackStep = 0
CamLight = 0.9411765,0.8509804,0.6117647,1.278839
BaseColor = 0.6588235,0.7803922,0.7803922
OrbitStrength = 0.6819205
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.5647059,0.6,0.6
GradientBackground = 0
CycleColors = false
Cycles = 1.1
EnableFloor = true
FloorNormal = 0,0,1
FloorHeight = -5
FloorColor = 0.568627,0.564706,0.443137
MI = 12
ColorIterations = 11
Size = 1.364568
CSize = 1.03042,1.04424,2
C = 2,0.0640466,-0.1513828
TThickness = 0.01
DEoffset = 0
Offset = 0,-0.0444444,0.68
EquiRectangular = false
FocalPlane = 0.6400602
Aperture = 0.0081967
ShowDepth = false
DepthMagnitude = 1
DetailAO = -1.86109
MaxDistance = 216.22
MaxRaySteps = 2283
AO = 0,0,0,0.7
Specular = 0.23552
SpecularExp = 100
SpecularMax = 10
SpotLight = 1,0.9411765,0.8039216,1
SpotLightDir = 0.5525321,0.5555556
CamLightMin = 0.0384906
Glow = 0.8666667,0.9490196,1,0.2233083
GlowMax = 370
Fog = 0.5852231
HardShadow = 1 NotLocked
ShadowSoft = 0.4996215
QualityShadows = true
Reflection = 0.7913239 NotLocked
DebugSun = false NotLocked
#endpreset

